<?php

namespace Microsoft\Graph\Generated\Teamwork\TeamsAppSettings;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * Get the tenant-wide teamsAppSettings for all Teams apps in the tenant.
*/
class TeamsAppSettingsRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new TeamsAppSettingsRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
